Attribute VB_Name = "API"
'             API
'--------------------------------------------------------------------------
Option Explicit

'  
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
':
'Sleep 100 '   0.1 

'--------------------------------------------------------------------------
'     Common Dialog

Type OpenFileName
    lStructSize         As Long
    hwndOwner           As Long
    hInstance           As Long
    lpstrFilter         As String
    lpstrCustomFilter   As String
    nMaxCustFilter      As Long
    nFilterIndex        As Long
    lpstrFile           As String
    nMaxFile            As Long
    lpstrFileTitle      As String
    nMaxFileTitle       As Long
    lpstrInitialDir     As String
    lpstrTitle          As String
    flags               As Long
    nFileOffset         As Integer
    nFileExtension      As Integer
    lpstrDefExt         As String
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As String
End Type
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOPENFILENAME As OpenFileName) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOPENFILENAME As OpenFileName) As Long

Function OpenDialog$(Optional ByVal DefaultFile$, Optional ByVal MasksList$)
'                 .
'
' :   .
'   - :    (  ).
'   - ,  ,
'    , .: ",*.txt, ,*.*"
'   (  ).
'
' : -     (    ).
'    -   218 .     .
'   SplitFName.
' -----------------------------------------------------------------------------------

Dim OpenFile As OpenFileName, EndName As Integer, sFilter As String, strIniFolder As String

DefaultFile$ = Trim(DefaultFile$)    ' (   )

'    
If MasksList$ = "" Then
  sFilter = " " & Chr$(0) & "*.*" & Chr$(0)
Else
  sFilter = Replace(MasksList$, ",", Chr$(0)) + Chr$(0) '  .
End If

Call SplitFName(DefaultFile$, strIniFolder, DefaultFile$) '    

'      GetOpenFileName
OpenFile.lStructSize = Len(OpenFile)
OpenFile.hwndOwner = 0
OpenFile.hInstance = 0
OpenFile.lpstrFilter = sFilter
OpenFile.nFilterIndex = 1
OpenFile.lpstrFile = Left$(DefaultFile$ + String$(255, 0), 255) + Chr$(0)
OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
OpenFile.lpstrFileTitle = OpenFile.lpstrFile
OpenFile.nMaxFileTitle = OpenFile.nMaxFile
OpenFile.lpstrInitialDir = strIniFolder
OpenFile.lpstrTitle = " "               '  
OpenFile.flags = 0

GetOpenFileName OpenFile                          '  API

'    
If InStr(OpenFile.lpstrFile, "\") = 0 Then
  OpenDialog$ = ""      '    ,  .
Else
  EndName = InStr(OpenFile.lpstrFile, Chr$(0))
  Select Case EndName
    Case 1:    OpenDialog$ = ""      '0    -   
    Case 0:    OpenDialog$ = ""      '  
    Case Else: OpenDialog$ = Left$(OpenFile.lpstrFile, EndName - 1)
  End Select
End If

End Function

Function SaveDialog$(Optional ByVal DefaultFile$, Optional ByVal MasksList$)
'                 .
'
' :   .
'   - :    (  ).
'   - ,  ,
'    , .: ",*.txt, ,*.*"
'   (  ).
'
' : -     (    ).
'    -   218 .     .
'   SplitFName.
' -----------------------------------------------------------------------------------

Dim OpenFile As OpenFileName, EndName As Integer, sFilter As String, strIniFolder As String

DefaultFile$ = Trim(DefaultFile$)
If MasksList$ = "" Then
  sFilter = " " & Chr$(0) & "*.*" & Chr$(0)
Else
  sFilter = Replace(MasksList$, ",", Chr$(0)) + Chr$(0)
End If
Call SplitFName(DefaultFile$, strIniFolder, DefaultFile$)
OpenFile.lStructSize = Len(OpenFile)
OpenFile.hwndOwner = 0
OpenFile.hInstance = 0
OpenFile.lpstrFilter = sFilter
OpenFile.nFilterIndex = 1
OpenFile.lpstrFile = Left$(DefaultFile$ + String$(255, 0), 255) + Chr$(0)
OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
OpenFile.lpstrFileTitle = OpenFile.lpstrFile
OpenFile.nMaxFileTitle = OpenFile.nMaxFile
OpenFile.lpstrInitialDir = strIniFolder
OpenFile.lpstrTitle = " "               '  
OpenFile.flags = 0

Do
  GetSaveFileName OpenFile                          '  API

  '    
  If InStr(OpenFile.lpstrFile, "\") = 0 Then
    SaveDialog$ = ""      '    ,  .
  Else
    EndName = InStr(OpenFile.lpstrFile, Chr$(0))
    Select Case EndName
      Case 1:    SaveDialog$ = ""      '0    -   
      Case 0:    SaveDialog$ = ""      '  
      Case Else: SaveDialog$ = Left$(OpenFile.lpstrFile, EndName - 1)
    End Select
  End If
  '   
  EndName = 0
  Call SplitFName(SaveDialog$, strIniFolder, sFilter)
  OpenFile.lpstrFile = Left$(sFilter + String$(255, 0), 255) + Chr$(0)
  If SaveDialog$ <> "" Then
    If Dir$(sFilter) <> "" Then EndName = MsgBox("   " + vbCrLf + sFilter + vbCrLf + "   ." + vbCrLf + "    ?", vbExclamation + vbYesNo, "  ")
  End If
Loop While EndName = vbNo

End Function


Public Sub SplitFName(ByVal FileSpec$, ByRef varFilePath$, ByRef varFileName$)
'        :
'  +      .
' FileSpec$ -  :     + 
' varFilePath$ - :  ()
' varFileName$ - :  ()
'   ,     .
'   ,    ,  .
' --------------------------------------------------------------------------
Dim tmp1 As Integer

varFilePath$ = ""
tmp1 = InStrRev(FileSpec$, "\")
'   ,   
If tmp1 > 0 Then
 varFilePath$ = Left$(FileSpec$, tmp1)
  If tmp1 = Len(FileSpec$) Then
    FileSpec$ = ""  '  ,     (  )
  Else
    FileSpec$ = Right$(FileSpec$, Len(FileSpec$) - tmp1)  '    
  End If
End If
' :
If Trim(FileSpec$) = "." Then FileSpec$ = ""
If Trim(FileSpec$) = ".." Then
  FileSpec$ = ""
  varFilePath$ = ".."
End If
varFileName$ = FileSpec$

End Sub
'-----------------------------------------------------------------------------

